<template>
  <component
    is="a-modal"
    :width="tool.getDevice() === 'mobile' ? '100%' : '600px'"
    v-model:visible="visible"
    :title="title"
    :mask-closable="false"
    :ok-loading="loading"
    @cancel="close"
    @before-ok="submit"
  >
    <!-- 表单信息 start -->
    <a-form
      ref="formRef"
      :model="formData"
      :rules="rules"
      :auto-label-width="true"
    >
      <a-form-item label="用户名" field="user_name">
        <a-input
          v-model="formData.user_name"
          disabled
          placeholder="请输入用户名"
        />
      </a-form-item>
      <a-form-item label="服务器名" field="server_name">
        <a-input
          v-model="formData.server_name"
          disabled
          placeholder="请输入玩家所在服务器的名称"
        />
      </a-form-item>

      <a-form-item label="角色名" field="role_name">
        <a-input
          v-model="formData.role_name"
          disabled
          placeholder="请输入角色名"
        />
      </a-form-item>
      <a-form-item label="广告位ID" field="site_id">
        <!-- <a-input v-model="formData.site_id" placeholder="请输入广告位ID" /> -->
        <a-select v-model="formData.site_id" placeholder="请选择广告位">
          <a-option
            v-for="item in agentSiteOptions"
            :key="item.id"
            :value="item.id"
            allow-search
          >
            [{{ item.id }}] {{ item.name }}
          </a-option>
        </a-select>
      </a-form-item>
    </a-form>
    <!-- 表单信息 end -->
  </component>
</template>

<script setup>
import { ref, reactive, computed } from "vue";
import tool from "@/utils/tool";
import { Message, Modal } from "@arco-design/web-vue";
import api from "../../api/customer/roleData";
import commonApi from "../../api/common";

const emit = defineEmits(["success"]);
// 引用定义
const visible = ref(false);
const loading = ref(false);
const formRef = ref();
const mode = ref("");
const agentSiteOptions = ref([]);

let title = computed(() => {
  return "角色查询" + (mode.value == "add" ? "-新增" : "-编辑");
});

// 表单初始值
const initialFormData = {
  id: null,
  site_id: null,
  server_name: "",
  user_name: "",
  role_name: "",
  platform: "",
};

// 表单信息
const formData = reactive({ ...initialFormData });

// 验证规则
const rules = {
  site_id: [{ required: true, message: "广告位ID必需填写" }],
};

// 打开弹框
const open = async (type = "add") => {
  mode.value = type;
  // 重置表单数据
  Object.assign(formData, initialFormData);
  formRef.value.clearValidate();
  visible.value = true;
  await initPage();
};

// 初始化页面数据
const initPage = async () => {
  await getAgentSiteOptions();
};

// 获取广告位options
const getAgentSiteOptions = async () => {
  const res = await commonApi.getAgentSiteOptionsApi();
  agentSiteOptions.value = res.data;
};

// 设置数据
const setFormData = async (data) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      formData[key] = data[key];
    }
  }
};

// 数据保存
const submit = async (done) => {
  const validate = await formRef.value?.validate();
  if (!validate) {
    loading.value = true;
    let data = { ...formData };
    let result = {};
    if (mode.value === "add") {
      // 添加数据
      data.id = undefined;
      result = await api.save(data);
    } else {
      // 修改数据
      result = await api.update(data.id, data);
    }
    if (result.code === 200) {
      Message.success("操作成功");
      emit("success");
      done(true);
    }
    // 防止连续点击提交
    setTimeout(() => {
      loading.value = false;
    }, 500);
  }
  done(false);
};

// 关闭弹窗
const close = () => (visible.value = false);

defineExpose({ open, setFormData });
</script>
